/* ADC test program */

#include <stdio.h>
#include <unistd.h>
#include "i2c.h"
#include "adc.h"

#include <propeller.h>

int main(void)
{
#if 0

    int adcAddr;
    I2C *bus;
    
    if (!(bus = i2cBootOpen())) {
        printf("error: can't open boot i2c bus\n");
        return 1;
    }
        
    /* check for the AD7993BRUZ-0 chip */
    if (DetectAdcChip(bus, AD7993BRUZ_0) == 0) {
        printf("AD7993BRUZ-0 found\n");
        adcAddr = AD7993BRUZ_0;
    }
    
    /* check for the AD7993BRUZ-1 chip */
    else if (DetectAdcChip(bus, AD7993BRUZ_1) == 0) {
        printf("AD7993BRUZ-1 found\n");
        adcAddr = AD7993BRUZ_1;
    }
    
    /* no adc chip found */
    else {
        printf("error: no adc chip found\n");
        return 1;
    }
        
    for (;;) {
        printf("adc[0] = %g\n", adcVolts(bus, adcAddr, 0));
        printf("adc[1] = %g\n", adcVolts(bus, adcAddr, 1));
        printf("adc[2] = %g\n", adcVolts(bus, adcAddr, 2));
        usleep(1000000);
    }
    
#else

    uint16_t buffer[3*16];
    ADC adc, *dev;
    
    if (!(dev = adcOpen(&adc, 28, 29, AD7993BRUZ_1, 7, 10000, buffer, 3*16))) {
        printf("error: can't open adc device\n");
        return 1;
    }
    
    for (;;) {
        uint16_t buf[3];
        adcRead(dev, buf, 3);
        printf("adc[%d] = %d\n", (buf[0] >> 12) & 3, buf[0] & 0x0fff);
        printf("adc[%d] = %d\n", (buf[1] >> 12) & 3, buf[1] & 0x0fff);
        printf("adc[%d] = %d\n", (buf[2] >> 12) & 3, buf[2] & 0x0fff);
        //printf("oPtr %04x, iPtr %04x\n", dev->state.mailbox.oPtr, dev->state.mailbox.iPtr);
    }
    
#endif
    
    return 0;
}

