#include <stdio.h>
#include "adc.h"
#include "i2c.h"

/* maximum number of retries */
#define I2C_RETRIES    5

/* booleans */
#ifndef TRUE
#define TRUE	1
#define FALSE	0
#endif

int DetectAdcChip(I2C *bus, int address)
{
    int retries = I2C_RETRIES;
    while (--retries >= 0) {
        if (i2cRead(bus, address, NULL, 0, TRUE) == 0)
            return 0;
    }
    return 1;
}

int adcIn(I2C *bus, int address, int channel)
{
    int retries = I2C_RETRIES;
    uint8_t buf[2];
    while (--retries >= 0) {
        buf[0] = 1 << (channel + 4);
        if (i2cWrite(bus, address, buf, 1, FALSE) == 0) {
            if (i2cRead(bus, address, buf, 2, TRUE) == 0) {
                if ((buf[0] >> 4) == channel)
                    return ((buf[0] & 0xf) << 6) | (buf[1] >> 2);
            }
        }
    }
    return -1;
}

double adcVolts(I2C *bus, int address, int channel)
{
    return ((double)adcIn(bus, address, channel) * 5.0) / 1024.0;
}
